{ ****************************************************************** }
{                                                                    }
{   Delphi component TDBFoneEdit                                     }
{                                                                    }
{   Simplifies entry of telephone numbers                            }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\program files\borland\compcrea\foneedit2.cd }
{   on 21 March 1997 at 17:55                                        }
{                                                                    }
{   Copyright  1997 by Computer Solutions:AZ                        }
{                                                                    }
{ ****************************************************************** }

unit FonEdit2;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Stdctrls, Dbctrls;

type
  TDBFoneEdit = class(TDBEdit)
    private
      { Private fields of TDBFoneEdit }
        { Storage for property AreaCode }
        FAreaCode : String;
        { Storage for property TollFree }
        FTollFree : Boolean;

      { Private methods of TDBFoneEdit }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        { Read method for property AreaCode }
        function GetAreaCode : String;
        { Write method for property AreaCode }
        procedure SetAreaCode(Value : String);
        { Read method for property TollFree }
        function GetTollFree : Boolean;
        { Write method for property TollFree }
        procedure SetTollFree(Value : Boolean);

    protected
      { Protected fields of TDBFoneEdit }

      { Protected methods of TDBFoneEdit }
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        procedure DoExit; override;
        procedure Change; override;
        procedure Loaded; override;

    public
      { Public fields and properties of TDBFoneEdit }

      { Public methods of TDBFoneEdit }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of the component }
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property OnKeyUp;
        property OnKeyDown;
        property OnKeyPress;
        property OnEnter;
        property OnExit;
        property OnChange;
        { Default Area Code }
        property AreaCode : String read GetAreaCode write SetAreaCode;
        { Is this a Toll Free Number? }
        property TollFree : Boolean
             read GetTollFree write SetTollFree
             default False;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TDBFoneEdit with CSA as its
       default page on the Delphi component palette }
     RegisterComponents('CSA', [TDBFoneEdit]);
end;

{ Method to set variable and property values and create objects }
procedure TDBFoneEdit.AutoInitialize;
begin
     FAreaCode := '520';
     FTollFree := False;
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TDBFoneEdit.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

{ Read method for property AreaCode }
function TDBFoneEdit.GetAreaCode : String;
begin
     Result := FAreaCode
end;

{ Write method for property AreaCode }
procedure TDBFoneEdit.SetAreaCode(Value : String);
begin
     FAreaCode := Value;
end;

{ Read method for property TollFree }
function TDBFoneEdit.GetTollFree : Boolean;
begin
     Result := FTollFree
end;

{ Write method for property TollFree }
procedure TDBFoneEdit.SetTollFree(Value : Boolean);
begin
     FTollFree := Value;
end;

{ Override OnClick handler from TDBEdit }
procedure TDBFoneEdit.Click;
begin
     { Code to execute before activating click
       behavior of component's parent class }

     { Activate click behavior of parent }
     inherited Click;

     { Code to execute after click behavior
       of parent }

end;

{ Override OnKeyPress handler from TDBEdit }
procedure TDBFoneEdit.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     { Key contains the character produced by the keypress.
       It can be tested or assigned a new value before the
       call to the inherited KeyPress method.  Setting Key
       to #0 before call to the inherited KeyPress method
       terminates any further processing of the character. }

     { Activate KeyPress behavior of parent }
     inherited KeyPress(Key);

     { Code to execute after KeyPress behavior of parent }

end;

{ Override OnExit handler from TDBEdit }
procedure TDBFoneEdit.DoExit;
var
 vAreaCode,vNum,vResult,vChar: String;
 vX : Integer;
begin
     inherited DoExit;
 vNum:=Text;
 vResult:='';
 // strip any punctuation entered by user.
 for vX:=1 to Length(vNum) do begin
  vChar:=Copy(vNum,vX,1);
  try
   // translate letters entered
   if (vChar='A') or (vChar='B') or (vChar='C') then vChar:='2';
   if (vChar='D') or (vChar='E') or (vChar='F') then vChar:='3';
   if (vChar='G') or (vChar='H') or (vChar='I') then vChar:='4';
   if (vChar='J') or (vChar='K') or (vChar='L') then vChar:='5';
   if (vChar='M') or (vChar='N') or (vChar='O') then vChar:='6';
   if (vChar='P') or (vChar='Q') or (vChar='R') or (vChar='S') then vChar:='7';
   if (vChar='T') or (vChar='U') or (vChar='V') then vChar:='8';
   if (vChar='W') or (vChar='X') or (vChar='Y') or (vChar='Z') then vChar:='9';
   if StrToInt(vChar) in [0..9] then vResult:=vResult+vChar;
  except
   // do nothing
  end; // try except block
 end; // for loop
 vNum:=vResult;
 // if only 7 numbers entered and toll free, add 800
 if (Length(vNum)=7) and (TollFree) then vNum:='800'+vNum;
 // if only 7 numbers entered, add default Area Code
 if Length(vNum)=7 then vNum:=AreaCode+vNum;
 // now format the number
 Text:='('+Copy(vNum,1,3)+') '+Copy(vNum,4,3)+'-'+Copy(vNum,7,4);
end;

{ Override OnChange handler from TDBEdit }
procedure TDBFoneEdit.Change;
begin
     inherited Change;
end;

constructor TDBFoneEdit.Create(AOwner: TComponent);
begin
     { Call the Create method of the parent class }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables and      }
     { properties; also, it creates objects for properties of       }
     { standard Delphi object types (e.g., TFont, TTimer,           }
     { TPicture) and for any variables marked as objects.           }
     { AutoInitialize method is generated by Component Create.      }
     AutoInitialize;

     { Code to perform other tasks when the component is created }
     Width:=80;
     CharCase:=ecUpperCase;
end;

destructor TDBFoneEdit.Destroy;
begin
     { AutoDestroy, which is generated by Component Create, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

procedure TDBFoneEdit.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;


end.
